/*
 * created by: Timo Lindhorst <timo.lindhorst@student.uni-magdeburg.de>
 */
 
import josx.platform.rcx.*;
import josx.util.*;
import java.lang.Math;

public class Robocontr {
  Controller contr;
  static final int TIMEOUT = 2500;
  int speed = 0;
  int direction = 1;
  
  public Robocontr() {
    contr = new Controller();
    contr.setSpeed(speed);
    contr.setDirection(direction);
    contr.start();
  }
  
  /*
   * update the controller with new values
   */
  public void update(byte param) {
    int speed;
    int direction;
    
    speed = (param >> 5) & 0x3;
    if ((param & 0x80) != 0) { speed *= -1; }
    direction = param & 0x0f;
    if ((param & 0x10) != 0) { direction *= -1; }
    
    if (speed != this.speed) {
	    contr.setSpeed(speed);
	    this.speed = speed;
    }
    if (direction != this.direction) {
	    contr.setDirection(direction);
	    this.direction = direction;
    }
  }
  
  public void timedOut() {
    contr.setSpeed(0);
    debug(9);
    Sound.buzz();
  }
  
  void debug(int n) {
    LCD.showNumber(n);
  }
	
  public static void main(String[] args) {
    Robocontr rc = new Robocontr();
    byte[] buffer = new byte[10];
    int counter = TIMEOUT + 1;
    
    while(true) {
      if (Serial.isPacketAvailable()) {
           
      	Serial.readPacket(buffer);
        if (buffer[0] == (byte) 0xf7) {
            rc.update(buffer[1]);
        }
        counter = 0;
      } else if (counter == TIMEOUT) {
         rc.timedOut();
         counter++;
      } else if (counter <= TIMEOUT) {
        counter++;
      } 
    }
  }
}
